
typedef struct {
    word32 S0[256], S1[256], S2[256], S3[256], P[18];
    word32 iv0, iv1;		       /* for CBC mode */
} BlowfishContext;

#define SSH_SESSION_KEY_LENGTH	32

#define GET_32BIT_LSB_FIRST(cp) \
  (((unsigned long)(unsigned char)(cp)[0]) | \
  ((unsigned long)(unsigned char)(cp)[1] << 8) | \
  ((unsigned long)(unsigned char)(cp)[2] << 16) | \
  ((unsigned long)(unsigned char)(cp)[3] << 24))

#define PUT_32BIT_LSB_FIRST(cp, value) do { \
  (cp)[0] = (value); \
  (cp)[1] = (value) >> 8; \
  (cp)[2] = (value) >> 16; \
  (cp)[3] = (value) >> 24; } while (0)

void blowfish_setkey(BlowfishContext *ctx,
                            const unsigned char *key, short keybytes);

void blowfish_encrypt_cbc(unsigned char *blk, int len,
                                 BlowfishContext *ctx);

void blowfish_decrypt_cbc(unsigned char *blk, int len,
				 BlowfishContext *ctx);
                                 