/* sshdos.c       Copyright (c) 2000 Nagy Daniel */

#include <stdio.h> 
#include <conio.h> 
#include <stdlib.h> 
#include <dos.h>
#include <tcp.h>
#include <stdarg.h> 
#include <sys/types.h> 
#include <sys/socket.h> 
#include <global.h>
#include <ssh.h>
#include <md5.h>
#include <rsa.h>
#include <des.h>
#include <blowfish.h>
#include <version.h>
#include <externs.h>

//#define DEBUG_PACKET 1

struct Packet pktin = { 0, 0, 0, NULL, 0 };
struct Packet pktout = { 0, 0, 0, NULL, 0 };

int cipher=0;		/* cipher of or off*/
int cipher_type;	/* type of cipher */

DESCon keys[3];		/* 3DES contexts */
BlowfishContext ectx, dctx; /* blowfish context */

unsigned char inbuf[532];  /* buffer for incoming raw packet */

tcp_Socket s;		/* socket */
int status;		/* status of communication */


#ifdef DEBUG_PACKET
FILE *filename;
#endif

/* client loop */

int dosession(void)
{
int len,i;

        if(kbhit()) keymap();

	sock_tick(&s, &status);
	len=sock_fastread(&s,inbuf,4);
	if(!len) return(0);
	for (i = len = 0; i < 4; i++) len = (len << 8) + inbuf[i];
	sock_read(&s,inbuf+4,len + 8 - (len%8));
	ssh_gotdata(inbuf);
#ifdef DEBUG_PACKET
		fwrite(pktin.body+4,pktin.length,1,filename);
		fprintf(filename,"\r\n");
#endif
	if(pktin.type==SSH_SMSG_STDOUT_DATA || pktin.type==SSH_SMSG_STDERR_DATA)
		{
		parse(pktin.body+4, pktin.length);
		return(0);
		}
	else if(pktin.type==SSH_SMSG_EXITSTATUS)
		{
		s_wrpkt_start(SSH_CMSG_EXIT_CONFIRMATION,0);
                s_wrpkt();
                return(EXIT_SSH);
		}
	else if(pktin.type==SSH_MSG_DISCONNECT)
		{
		pktin.body[pktin.length+4]=0;
		puts(pktin.body+4);
		return(EXIT_SSH);
		}
	else if(pktin.type==SSH_SMSG_SUCCESS)
		{
		return(0);
		}
	else
		{
		printf("Unsupported packet received. Type: %d\n",pktin.type);
		return(0);
		}

sock_err:
  switch (status)
  {
    case 1 : cputs ("Connection closed");
             break;
    case -1: cputs ("REMOTE HOST CLOSED CONNECTION");
             break;
  }
  return(EXIT_SSH);

}

/* SSH version string exchange */

void ssh_exchange_identification(void)
{
  char buf[256], remote_version[256];
  int remote_major, remote_minor, i;
  int my_major, my_minor;
  int len, cl, dat;
  unsigned int sw;

  /* Read other side's version identification. */
      i=sock_gets(&s, buf, sizeof(buf));
		if(i==0) fatal("read: %s", strerror(errno));
      buf[i] = '\n';

  printf("Remote version: %s",buf);
  /* Check that the versions match.  In future this might accept several
     versions and set appropriate flags to handle them. */
  if (sscanf(buf, "SSH-%d.%d-%[^\n]\n", &remote_major, &remote_minor,
	     remote_version) != 3)
    fatal("Bad remote protocol version identification\n");

  switch (check_emulation(remote_major, remote_minor,
		     &my_major, &my_minor))
    {
    case EMULATE_VERSION_TOO_OLD:
      fatal("Remote machine has too old SSH software version\n");
    case EMULATE_MAJOR_VERSION_MISMATCH:
      fatal("Major protocol versions incompatible\n");
    case EMULATE_VERSION_NEWER:
      /* We will emulate the old version. */
      break;
    case EMULATE_VERSION_OK:
      break;
    default:
      fatal("Unexpected return value from check_emulation\n");
    }

  sprintf(buf, "SSH-%d.%d-%s\n\0",
	  my_major, my_minor, SSH_VERSION);
  printf("Local version: %s",buf);
  len=sock_write(&s, buf, strlen(buf));
  if(len!= strlen(buf)) fatal("write: %s", strerror(errno));
}

/* check_emulation: take the remote party's version number as
   arguments and return our possibly modified version number back
   (relevant only for clients).

   Return values:
   EMULATE_VERSION_OK means we can work together

   EMULATE_VERSION_TOO_OLD if the other party has too old version
   which we cannot emulate,

   EMULATE_MAJOR_VERSION_MISMATCH if the other party has different
   major version and thus will probably not understand anything we
   say, and

   EMULATE_VERSION_NEWER if the other party has never code than we
   have.

   */

int check_emulation(int remote_major, int remote_minor,
		    int *return_major, int *return_minor)
{
  if (return_major)
    *return_major = PROTOCOL_MAJOR;
  if (return_minor)
    {
      if (remote_minor < PROTOCOL_MINOR)
	*return_minor = remote_minor;
      else
	*return_minor = PROTOCOL_MINOR;
    }

  if (remote_major < PROTOCOL_MAJOR)
    return EMULATE_MAJOR_VERSION_MISMATCH;

  if (remote_major == 1 && remote_minor == 0)
    return EMULATE_VERSION_TOO_OLD;  /* We no longer support 1.0. */
  
  if (remote_major > PROTOCOL_MAJOR ||
      (remote_major == PROTOCOL_MAJOR && remote_minor > PROTOCOL_MINOR))
    {
      /* The remote software is newer than we. If we are the client,
	 no matter - the server will decide. If we are the server, we
	 cannot emulate a newer client and decide to stop. */
      return EMULATE_VERSION_NEWER;
    }

  return EMULATE_VERSION_OK;
}

/* create session key and ID */

void create_ssh_keys(void)
{
int i,len;
unsigned char session_key[32];
unsigned char session_id[16];
unsigned char *RSAblock, *keystr1, *keystr2;
unsigned char cookie[8];

R_RSAKey servkey, hostkey;
MD5Context md5c;


    memcpy(cookie, pktin.body, 8);
    cputs("Extracting server keys...");
    i=makekey(pktin.body+8, &servkey, &keystr1);
    makekey(pktin.body+8+i, &hostkey, &keystr2);
    puts("Done");

    cputs("Generating session ID...");
    MD5Init(&md5c);
    MD5Update(&md5c, keystr2, hostkey.bytes);
    MD5Update(&md5c, keystr1, servkey.bytes);
    MD5Update(&md5c, cookie, 8);
    MD5Final(session_id, &md5c);
    puts("Done");

    for (i=0; i<32; i++)
	session_key[i] = rand() % 256;

    len = (hostkey.bytes > servkey.bytes ? hostkey.bytes : servkey.bytes);

    RSAblock = malloc(len);
    if (!RSAblock)
	fatal("Out of memory\n");

    memset(RSAblock,0,len);

    for (i=0; i<32; i++) {
	RSAblock[i] = session_key[i];
	if (i < 16)
	    RSAblock[i] ^= session_id[i];
    }


    cputs("Encrypting session key...");
    if (hostkey.bytes > servkey.bytes) {
	rsaencrypt(RSAblock, 32, &servkey);
	rsaencrypt(RSAblock, servkey.bytes, &hostkey);
    } else {
	rsaencrypt(RSAblock, 32, &hostkey);
	rsaencrypt(RSAblock, hostkey.bytes, &servkey);
    }
    puts("Done");

    s_wrpkt_start(SSH_CMSG_SESSION_KEY, len+15);
    pktout.body[0] = cipher_type;
    memcpy(pktout.body+1, cookie, 8);
    pktout.body[9] = (len*8) >> 8;
    pktout.body[10] = (len*8) & 0xFF;
    memcpy(pktout.body+11, RSAblock, len);
    pktout.body[len+11] = pktout.body[len+12] = 0;
    pktout.body[len+13] = pktout.body[len+14] = 0;
    cputs("Sending encrypted session key...");
    s_wrpkt();
    puts("Done");
    free(RSAblock);

   switch(cipher_type)
	{
	case SSH_CIPHER_3DES:
		des_set_key(session_key, &keys[0]);
		des_set_key(session_key+8, &keys[1]);
		des_set_key(session_key+16, &keys[2]);
		break;

	case SSH_CIPHER_BLOWFISH:
		blowfish_setkey(&ectx, session_key, 32);
		    ectx.iv0 = 0;
		    ectx.iv1 = 0;
		    dctx = ectx;
		break;
	}

	cipher=1;

}

/* create header for raw outgoing packet */

void s_wrpkt_start(int type, int len) {
    int pad, biglen;

    len += 5;			       /* type and CRC */
    pad = 8 - (len%8);
    biglen = len + pad;

    pktout.length = len-5;
    if (pktout.maxlen < biglen) {
	pktout.maxlen = biglen;
	pktout.data = (pktout.data == NULL ? malloc(biglen) :
		       realloc(pktout.data, biglen));
	if (!pktout.data)
	    fatal("Out of memory\n");
    }

    pktout.type = type;
    pktout.body = pktout.data+4+pad+1;
}

/* create outgoing packet */

void s_wrpkt(void)
{
    int pad, len, biglen, i;
    unsigned long crc;
    unsigned char *p;

    len = pktout.length + 5;	       /* type and CRC */
    pad = 8 - (len%8);
    biglen = len + pad;

    pktout.body[-1] = pktout.type;
    for (i=0; i<pad; i++)
	pktout.data[i+4] = rand() % 256;
    crc = crc32(pktout.data+4, biglen-4);

    pktout.data[biglen+0] = (unsigned char) ((crc >> 24) & 0xFF);
    pktout.data[biglen+1] = (unsigned char) ((crc >> 16) & 0xFF);
    pktout.data[biglen+2] = (unsigned char) ((crc >> 8) & 0xFF);
    pktout.data[biglen+3] = (unsigned char) (crc & 0xFF);

    pktout.data[0] = (len >> 24) & 0xFF;
    pktout.data[1] = (len >> 16) & 0xFF;
    pktout.data[2] = (len >> 8) & 0xFF;
    pktout.data[3] = len & 0xFF;

    if (cipher)
	switch(cipher_type)
		{
		case SSH_CIPHER_3DES:
		  des_3cbc_encrypt(pktout.data+4, pktout.data+4, biglen, keys);
		break;

		case SSH_CIPHER_BLOWFISH:
		  blowfish_encrypt_cbc(pktout.data+4, biglen, &ectx);
		break;
		}

    if(sock_write(&s, pktout.data, biglen+4) != biglen+4)
	        fatal("write: %s", strerror(errno));

}

/* get password */

void ask_password(void)
{
int len;
unsigned char *password, ch;
	password=malloc((unsigned char)30);
	len=0;
	printf("Password: ");
	while(ch!=0x0d)
		{
		ch=password[len]=getch();
		len++;
		}
	password[len]=0;
	len--;
	printf("\n");
	s_wrpkt_start(9, len+4);
	pktout.body[0] = pktout.body[1] = pktout.body[2] = 0;
	pktout.body[3] = len;
	memcpy(pktout.body+4, password, len);
	s_wrpkt();
	memset(password, 0, strlen(password));
	free(password);
}

/* allocate a pseudo terminal */

void request_pty(void)
{
int i, len;
        i = strlen("vt100");
	s_wrpkt_start(10, i+5*4+1);
        pktout.body[0] = (i >> 24) & 0xFF;
        pktout.body[1] = (i >> 16) & 0xFF;
        pktout.body[2] = (i >> 8) & 0xFF;
        pktout.body[3] = i & 0xFF;
	memcpy(pktout.body+4, "vt100", i);
        memset(pktout.body+9, 0, 17);
        pktout.body[12]=25;
        pktout.body[16]=80;
	s_wrpkt();
}

/* start interactive shell */

void start_shell(void)
{
int len;
    s_wrpkt_start(12, 0);
    s_wrpkt();
}

/* get a packet with blocking */

int packet_read_block(void)
{
                sock_wait_input(&s,sock_delay,NULL,&status);
		sock_fastread(&s,inbuf,sizeof(inbuf));
		ssh_gotdata(inbuf);
return(0);

sock_err:
  switch (status)
  {
    case 1 : puts ("Connection closed");
             break;
    case -1: puts ("REMOTE HOST CLOSED CONNECTION");
             break;
  }
  exit(1);
}

/* expect a packet type */

void packet_read_expect(int type)
{
      packet_read_block();
      if(pktin.type!=type) fatal("Invalid answer from server\n");
}

/* convert raw, encrypted packet to readable structure */

void ssh_gotdata(unsigned char *data)
{
    long len, biglen;
    int i, pad;

	for (i = len = 0; i < 4; i++) len = (len << 8) + data[i];
	pad = 8 - (len%8);
	biglen = len + pad;
        data+=4;

        pktin.data = (pktin.data == NULL ? malloc(biglen+2) :
			realloc(pktin.data, biglen+2));
	    if (!pktin.data)
		fatal("Out of memory\n");

        memcpy(pktin.data+2, data, biglen);     /* copy first chunk */
	pktin.length=biglen-4-pad-5;

	if(cipher)
	   switch(cipher_type)
		{
		case SSH_CIPHER_3DES:
		  des_3cbc_decrypt(pktin.data+2, pktin.data+2, biglen, keys);
		break;

		case SSH_CIPHER_BLOWFISH:
		  blowfish_decrypt_cbc(pktin.data+2, biglen, &dctx);
		break;
		}
\
	pktin.type = pktin.data[pad+2];
	pktin.body = pktin.data+pad+1+2;
}

/* fatal error handler */

void fatal(const char *fmt, ...)
{
 va_list ap;
  char buf[1024];

  va_start(ap, fmt);
  vsprintf(buf, fmt, ap);
  va_end(ap);
  fprintf(stderr, "%s\n", buf);
  sock_close(&s);
  exit(255);
}

/* main program */

int main(int argc, char **argv)
{
int i, ch, localport;
unsigned char *username=NULL, *remotehost;
DWORD remoteip;
char *usage="Usage: sshdos [-c cipher] username remote_hostname\n"
	    "Valid ciphers are: 3des, blowfish. Default is 3des.";

	printf("SSHDOS v%s\n", SSH_VERSION);

	while((ch=getopt(argc, argv,"c:")) != EOF)

	switch (ch)
		{
		case 'c':
		if(!strncmp(optarg,"3des",4)) cipher_type=SSH_CIPHER_3DES;
		if(!strncmp(optarg,"blowfish",8)) cipher_type=SSH_CIPHER_BLOWFISH;
		if(!cipher_type)
			{
			printf("Invalid cipher type");
			exit(1);
			}
		break;

		default:
		puts(usage);
		exit(1);
		}

  argc -= optind;
  argv += optind;

  if (argc < 2)
	{
	puts(usage);
	exit(1);
	}

  if(!cipher_type) cipher_type=SSH_CIPHER_3DES;

    username=argv[0];
    remotehost=argv[1];

    srand (time(NULL));

    localport = (rand() & 512) + 512;       /* return 511 < port < 1024 */

    sock_init();

    if ((remoteip = resolve(remotehost)) == 0)
     {
       printf("\n\rUnable to resolve `%s'\n\r", remotehost);
       return(1);
     }

    if (!tcp_open(&s, localport, remoteip, SSH_PORT, NULL))
     {
       puts("Unable to open connection");
       return(1);
     }

    puts("waiting for remote host to connect...");
    fflush(stdout);
    sock_wait_established (&s, sock_delay,NULL, &status);

    sock_wait_input (&s, sock_delay, NULL, &status);

#ifdef DEBUG_PACKET
filename=fopen("debug","wb");
#endif

    /* Start negotiation on network */
    puts("Identification Exchange");
    ssh_exchange_identification();
    sock_tick(&s, &status);

    /* Wait for a public key packet from the server. */
    puts("Wait for public key");
    packet_read_expect(SSH_SMSG_PUBLIC_KEY);

    create_ssh_keys();

    puts("Waiting for first encrypted ACK");
    packet_read_block();
    if(pktin.type!=SSH_SMSG_SUCCESS)
	     fatal("Invalid response\n");

    i=strlen(username);
    s_wrpkt_start(4, i+4);
    pktout.body[0] = pktout.body[1] = pktout.body[2] = 0;
    pktout.body[3] = i;
    memcpy(pktout.body+4, username, i);
    s_wrpkt();

    packet_read_expect(SSH_SMSG_FAILURE);

    ask_password();
    packet_read_block();
    if(pktin.type!=SSH_SMSG_SUCCESS)
		      fatal("Invalid password\n");

    request_pty();
    packet_read_expect(SSH_SMSG_SUCCESS);

    start_shell();


while(EXIT_SSH!=dosession());

#ifdef DEBUG_PACKET
fclose(filename);
#endif

sock_close(&s);
sock_wait_closed(&s, sock_delay, NULL, &status);
return(0);

sock_err:
  switch (status)
  {
    case 1 : cputs ("Connection closed");
             break;
    case -1: cputs ("REMOTE HOST CLOSED CONNECTION");
             break;
  }
  return(1);
}
