#include<stdio.h>
#include<conio.h>
#include<mem.h>
#include<ssh.h>

extern void fatal(const char *errormsg, ...);
extern void s_wrpkt_start(int,int);
extern void s_wrpkt(void);
extern struct Packet pktout;

struct vtstate{			/* vt100 state */
	int escflag;
	int escparams[8];
	int escparamptr;
	int attrib;
	int bold,underline,blink,inverse,x,y;
	};

static struct vtstate vt100state={0,0,0,0,0,0,0,0,0,0,0x7,0,0,0,0,0,0};

int esclength(unsigned char *ptr, int maxlen)
{
int i;
for(i=0;i<maxlen;i++) if(ptr[i]>'A' && ptr[i]!='[') return(0);
return(1);
}


int parse(unsigned char *ptr, int len)
{
int i;
textattr(vt100state.attrib);

if(vt100state.escflag)		/* process an older ESC sequence if any */
	{
	ptr-=vt100state.escparamptr;
	memcpy(ptr,vt100state.escparams,vt100state.escparamptr);
	len+=vt100state.escparamptr;
	}


  while(len)
	{
	   if(*ptr!=0x1b)
		{
		putch(*ptr);
		ptr++;
		len--;
		}
	     else
		{
		vt100state.escflag=1;
		if(esclength(ptr,len))
		   {
		   vt100state.escparamptr=len;
		   memcpy(vt100state.escparams,ptr,vt100state.escparamptr);
		   return(0);
		   }
		vt100state.escparamptr=0;
		memset(vt100state.escparams,0,8);
		ptr++;
		len--;
			if(len<0) fatal("VT100");
		if(*ptr!='[')
		   switch(*ptr)
			{
			default:
			    vt100state.escflag=0;
			    break;
		}
		else
		 {
		 ptr++;
		 len--;
			if(len<0) fatal("VT100");
		 while(vt100state.escflag)
		  {
		   switch(*ptr)
			{
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':
				if(vt100state.escparams[vt100state.escparamptr]<0)
					vt100state.escparams[vt100state.escparamptr]=0;
				vt100state.escparams[vt100state.escparamptr]*=10;
				vt100state.escparams[vt100state.escparamptr]+=*ptr-'0';
				break;

			case ';':
				vt100state.escparamptr++;
				break;

			case 'A':	/* cursor up */
				vt100state.x=wherex();
				vt100state.y=wherey();
				if(vt100state.escparams[0]<2)
					vt100state.y--;
				else vt100state.y-=vt100state.escparams[0];
				gotoxy(vt100state.x,vt100state.y);
				vt100state.escflag=0;
				break;

			case 'B':	/* cursor down */
				vt100state.x=wherex();
				vt100state.y=wherey();
				if(vt100state.escparams[0]<2)
					vt100state.y++;
				else vt100state.y+=vt100state.escparams[0];
				gotoxy(vt100state.x,vt100state.y);
				vt100state.escflag=0;
				break;

			case 'C':	/* cursor forward */
				vt100state.x=wherex();
				vt100state.y=wherey();
				if(vt100state.escparams[0]<2)
					vt100state.x++;
				else vt100state.x+=vt100state.escparams[0];
				gotoxy(vt100state.x,vt100state.y);
				vt100state.escflag=0;
				break;

			case 'D':	/* cursor backward */
				vt100state.x=wherex();
				vt100state.y=wherey();
				if(vt100state.escparams[0]<2)
					vt100state.x--;
				else vt100state.x-=vt100state.escparams[0];
				gotoxy(vt100state.x,vt100state.y);
				vt100state.escflag=0;
				break;

			case 'H':	/* cursor position */
				if(vt100state.escparams[0]==0) vt100state.escparams[0]=1;
				if(vt100state.escparams[1]==0) vt100state.escparams[1]=1;
				gotoxy(vt100state.escparams[1],vt100state.escparams[0]);
				vt100state.escflag=0;
				break;

			case 'J':	/* erase in display */
		/*0 - Erase from the active position to the end of the screen,
		    inclusive (default)
		1 - Erase from start of the screen to the active position,
		    inclusive
		2 = Erase all of the display -- all lines are erased, changed
		    to single-width, and the cursor does not move.*/
				vt100state.x=wherex();
				vt100state.y=wherey();
				clrscr();
				gotoxy(vt100state.x,vt100state.y);
				vt100state.escflag=0;
				break;

			case 'K':	/* erase in line */
		/*0 = Erase from the active position to the end of the line,
		    inclusive (default)
		1 - Erase from the start of the screen to the active position,
		    inclusive
		2 - Erase all of the line, inclusive*/
				vt100state.x=wherex();
				vt100state.y=wherey();
				switch(vt100state.escparams[0])
				   {
				   case 0:
					clreol();
					break;
				   case 1:
//					gotoxy(1,vt100state.y);
					for(i=0;i<vt100state.x;i++); putch(' ');
					break;
				   case 2:
//					gotoxy(1,vt100state.y);
					for(i=0;i<80;i++) putch(' ');
					break;
				   }
				vt100state.escflag=0;
				break;

			case 'R':	/* Cursor position report */
				vt100state.escflag=0;
				break;

			case 'm':	/* attribute */
					/* 0 - turn off all */
					/* 1 - bold*/
					/* 4 - underscore */
					/* 5 - blink */
					/* 7 - inverse */
				switch(vt100state.escparams[0])
				   {
				   case 0:
					vt100state.bold=0;
					vt100state.underline=0;
					vt100state.blink=0;
					vt100state.inverse=0;
					vt100state.attrib=0x07;
					textattr(vt100state.attrib);
					break;

				   case 1:
					vt100state.bold=1;
					highvideo();
					break;

				   case 4:
					vt100state.underline=1;
					highvideo();
					break;

				   case 5:
					vt100state.blink=1;
					textattr(vt100state.attrib+BLINK);
					break;

				   case 7:
					vt100state.inverse=1;
					vt100state.attrib=0x70;
					textattr(vt100state.attrib);
					break;
				   }
				vt100state.escflag=0;
				break;

			case 'r':	/* set top and bottom margin */
				window(1,vt100state.escparams[0],80,vt100state.escparams[1]);
				vt100state.escflag=0;
				break;

			default:
				vt100state.escflag=0;
				break;
			} /* switch*/
		     ptr++;
		     len--;
			if(len<0) fatal("VT100");
		     } /*while*/
		    } /* else */
		} /* else */
	} /* while*/
return(0);
}


void keymap(void)
{
unsigned char ch;

  ch=getch();
	if(ch==0)
	   {
	   ch=getch();
       		s_wrpkt_start(16,7);
       		pktout.body[0]=0;
       		pktout.body[1]=0;
       		pktout.body[2]=0;
       		pktout.body[3]=3;
       		pktout.body[4]=0x1b;
       		pktout.body[5]='[';
		switch(ch)
		  {
		  case 'H':
       		  pktout.body[6]='A';	/* up arrow */
		  break;

		  case 'P':
       		  pktout.body[6]='B';	/* down arrow */
		  break;

		  case 'K':
       		  pktout.body[6]='D';	/* left arrow */
		  break;

		  case 'M':
       		  pktout.body[6]='C';	/* right arrow */
		  break;
		  }
	   }
	else if(ch==0x1b)
	  {
       		s_wrpkt_start(16,5);
       		pktout.body[0]=0;
       		pktout.body[1]=0;
       		pktout.body[2]=0;
       		pktout.body[3]=1;
       		pktout.body[4]=0x3;
	   }
	else
	   {
       		s_wrpkt_start(16,5);
       		pktout.body[0]=0;
       		pktout.body[1]=0;
       		pktout.body[2]=0;
       		pktout.body[3]=1;
       		pktout.body[4]=ch;
	    }
        s_wrpkt();
}
