#
#   Borland/Turbo C makefile for SSHDOS v0.5
#

#   Where is your compiler installed?
COMPPATH=\borlandc
#COMPPATH=c:\bc31
#COMPPATH=c:\tc

# What compiler do you use?
# uncomment for Borland C
CC=bcc
# uncomment for Turbo C
#CC=tcc

# Compiler flags
# uncomment for Borland/Turbo C
# remove -DCOLOR to force B&W mode
CFLAGS= -y -v -c -1 -ml -Od -I$(COMPPATH)\include -I.\include -DCOLOR

# Linker flags
# uncomment for Borland/Turbo C
LFLAGS= -v -ml -l-c -lm -L$(COMPPATH)\lib -L.\lib

#################################################################
# In normal cases, no other settings should be changed below!!! #
#################################################################

LINKLINE= sshdos.obj wattcplg.lib crypto.lib ssh.lib vt100.lib

.c.obj:
	$(CC) $(CFLAGS) $*.c

sshdos.exe : sshdos.obj lib/crypto.lib lib/ssh.lib lib/vt100.lib
	$(CC) $(LFLAGS) $(LINKLINE)

sshdos.obj: sshdos.c
negotiat.obj: negotiat.c
protocol.obj: protocol.c
sshmd5.obj: sshmd5.c
sshdes.obj: sshdes.c
sshblowf.obj: sshblowf.c
sshcrc.obj: sshcrc.c
sshrsa.obj: sshrsa.c
vttio.obj: vttio.c
vidio.obj: vidio.c
keyio.obj: keyio.c

lib/crypto.lib: sshcrc.obj sshrsa.obj sshblowf.obj sshdes.obj sshmd5.obj
	tlib lib\crypto.lib -+sshcrc.obj -+sshrsa.obj -+sshblowf.obj -+sshdes.obj -+sshmd5.obj

lib/ssh.lib: negotiat.obj protocol.obj
	tlib lib\ssh.lib -+negotiat.obj -+protocol.obj

lib/vt100.lib: vttio.obj vidio.obj keyio.obj
	tlib lib\vt100.lib -+vttio.obj -+vidio.obj -+keyio.obj

clean:
	del lib\*.bak
	del *.obj
	del *.map
	del lib\vt100.lib
	del lib\crypto.lib
	del lib\ssh.lib
	del sshdos.exe
